package com.steerinfo.baseinfo.appverificationcode.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.appverificationcode.model.AppVerificationCode;
import com.steerinfo.baseinfo.appverificationcode.service.IAppVerificationCodeService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * AppVerificationCode RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-16 04:15
 * 类描述
 * 修订历史：
 * 日期：2022-03-16
 * 作者：generator
 * 参考：
 * 描述：AppVerificationCode RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/appverificationcodes")
public class AppVerificationCodeController extends BaseRESTfulController {

    @Autowired
    IAppVerificationCodeService appVerificationCodeService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appverificationcode:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppVerificationCode> list = appVerificationCodeService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("appverificationcode:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<AppVerificationCode> list = appVerificationCodeService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据AppVerificationCode对象创建")
    @ApiImplicitParam(name = "appVerificationCode", value = "详细实体appVerificationCode", required = true, dataType = "AppVerificationCode")
    //@RequiresPermissions("appverificationcode:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute AppVerificationCode model){
        AppVerificationCode appVerificationCode = appVerificationCodeService.add(model);
        return success(appVerificationCode);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appverificationcode:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        AppVerificationCode appVerificationCode = appVerificationCodeService.getById(id);
        return success(appVerificationCode);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的appVerificationCode信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "appVerificationCode", value = "详细实体appVerificationCode", required = true, dataType = "AppVerificationCode")
    })
    //@RequiresPermissions("appverificationcode:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody AppVerificationCode model){
        model.setId(id);
        AppVerificationCode appVerificationCode = appVerificationCodeService.modify(model);
        return success(appVerificationCode);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("appverificationcode:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  appVerificationCodeService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "电话短信发送功能-酒钢信息发送平台", notes = "电话短信发送功能-酒钢信息发送平台")
    @GetMapping(value = "/sendInfo")
    public RESTfulResult sendInfo(@RequestParam String phoneNum) {
        RESTfulResult rm = failed();
        int len = phoneNum.length();
        try{
            if(len != 11){
                rm.setMessage("电话号码为无效号码！！");
            }else{
                appVerificationCodeService.sendInfo(phoneNum);
                rm = success();
            }
        }catch(Exception e){
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！！");
        }
        return rm;
    }
}
